#!/bin/bash
NODE_EXPORTER_FOLDER="/var/lib/prometheus/node-exporter"
METRICS_FILE_NAME="k8s_compute_exporter_metrics.prom"
K8S_COMPUTE_METRICS_PATH="${NODE_EXPORTER_FOLDER}/${METRICS_FILE_NAME}"
TMP_METRICS_PATH=$(mktemp)
{% if k8s_compute_exporter_kubeconfig %}
export KUBECONFIG="{{ k8s_compute_exporter_kubeconfig }}"
{% endif %}

# Create temporary log file
NODES_STATUS=$({{ k8s_compute_exporter_krew_install_dir }}/kubectl-check nodes >/dev/null 2>&1 ; echo $(($? > 1 ? 0 : 1)))
NETWORK_STATUS=$({{ k8s_compute_exporter_krew_install_dir }}/kubectl-check network >/dev/null 2>&1 ; echo $(($? > 1 ? 0 : 1)))
DNS_STATUS=$({{ k8s_compute_exporter_krew_install_dir }}/kubectl-check dns --internal-domain kubernetes.default.svc.{{ k8s_compute_exporter_cluster_domain }} >/dev/null 2>&1 ; echo $(($? > 1 ? 0 : 1)))

# Calculate metrics
TIMESTAMP=$(date +%s)

# Write the status of the K8s compute nodes
echo "# HELP Reports the status of the K8s compute nodes." >> "${TMP_METRICS_PATH}"
echo "# TYPE skao_k8s_compute_status gauge" >> "${TMP_METRICS_PATH}"
echo "skao_k8s_compute_status{datacentre=\"{{ prometheus_datacentre }}\", check=\"nodes\"} ${NODES_STATUS}" >> "${TMP_METRICS_PATH}"
echo "skao_k8s_compute_status{datacentre=\"{{ prometheus_datacentre }}\", check=\"network\"} ${NETWORK_STATUS}" >> "${TMP_METRICS_PATH}"
echo "skao_k8s_compute_status{datacentre=\"{{ prometheus_datacentre }}\", check=\"dns\"} ${DNS_STATUS}" >> "${TMP_METRICS_PATH}"

# Write the timestamp of this check, useful to check if the cronjob is running normally
echo "# HELP skao_k8s_compute_status_update_seconds The timestamp of the last K8s compute node metrics update." >> "${TMP_METRICS_PATH}"
echo "# TYPE skao_k8s_compute_status_update_seconds counter" >> "${TMP_METRICS_PATH}"
echo "skao_k8s_compute_status_update_seconds ${TIMESTAMP}" >> "${TMP_METRICS_PATH}"

# Make metrics file world readable
chmod 644 "${TMP_METRICS_PATH}"

# Atomically update the prometheus metrics file
echo ${TMP_METRICS_PATH}
mv "${TMP_METRICS_PATH}" "${K8S_COMPUTE_METRICS_PATH}"
